echo off
 rem ===RETAIN.BAT, vs. 2.0, 11/12-92===
if "%1"=="" echo --- RETAIN 2.0 (c) 1992, Jim Groeneveld; retains current path up to 7 levels.
 rem if no argument at all make first one dummy + to auto-set second one later:
if "%1"=="" %0 +
if "%1"=="?" goto Help
if "%1"=="/?" goto Help
if "%1"=="-?" goto Help
if "%1"==".path" goto Path
 rem if second argument (return-file specification) not given determine it:
 rem (no check on erroneous presence of .BAT extension possible)
if "%2"=="" goto AltRtn
if "%1"==".notfound" goto NoPath
if "%1"=="*" if exist %2.BAT %2 *
if "%1"=="*" if not exist %2.BAT goto NoList
if "%1"==".list" goto List
if "%1"==".recreate" goto Create
if "%1"==".return" goto RETURN
if "%1"==".reversed" goto RETURN
if not "%1"=="+" goto RETAIN
  rem %1 is the location or specification of the auxiliary file $RETURN$.AUX

:Determine
 rem Determination of location (and name) of auxiliary file $RETURN$.AUX in/as:
 rem a. the first and only parameter when calling RETAIN (not checked here)
 rem    1. the full _path_ only, incl. trailing '\' (e.g. 'RETAIN C:\UTIL\') or
 rem    2. the full _file_specification_ (e.g. 'RETAIN C:\UTIL\AUX-FILE.$$$')
 rem b. the environment variable %RETAIN%
 rem    1. the full _path_ only, incl. trailing '\' ('SET RETAIN=C:\UTIL\') or
 rem    2. the full _file_specification_ ('SET RETAIN=C:\UTIL\AUX-FILE.$$$')
 rem c. the ROOT directory of C: (C:\) (or automatically any APPENDed path) or
 rem d. the ROOT directory of the CURRENT drive (\) or
 rem e. the CURRENT directory (.\) or
 rem f. the PARENT directory of the current one (..\) or
 rem g. the SAME directory where RETAIN.BAT is residing:
 rem    if EXPLICITELY specified when starting RETAIN (DOS 3.x&up only).
 rem    (NOT if RETAIN.BAT can only be found via the PATH!) or
 rem h. the DOS PATH variable (this may take quite a while)
 rem If the environment variable has not been set: try other location(s)
if "%RETAIN%"=="" goto NoEnvVar
 rem If $RETURN$.AUX found as file specified by %RETAIN% then restart this batch
 rem file (RETAIN.BAT as %0) with _full_path_&_file_name_ as the first parameter
if exist %RETAIN% %0 %RETAIN% %2
 rem If $RETURN$.AUX found in path specified by %RETAIN% then restart this batch
 rem file (RETAIN.BAT as %0) with _full_path_&_file_name_ as the first parameter
if exist %RETAIN%$RETURN$.AUX %0 %RETAIN%$RETURN$.AUX %2
 rem If the auxiliary file thus can not be found: try other location(s) below:

:NoEnvVar
 rem Check the presence of $RETURN$.AUX in (and specify _full_path_&_file_name_
 rem if found):
 rem (the root of C:)
if exist    C:\$RETURN$.AUX %0    C:\$RETURN$.AUX %2
 rem (the root of the current drive)
if exist      \$RETURN$.AUX %0      \$RETURN$.AUX %2
 rem (the current directory)
if exist     .\$RETURN$.AUX %0     .\$RETURN$.AUX %2
 rem (the parent directory)
if exist    ..\$RETURN$.AUX %0    ..\$RETURN$.AUX %2
 rem (the explicitely specified directory)
if exist %0\..\$RETURN$.AUX %0 %0\..\$RETURN$.AUX %2

 rem ---DOSPATH---
 rem Within the subroutine :Path to be called now by subsequent 'shift'ing
 rem the call name for RETAIN (%0) gets lost (as well as the in version 2.0
 rem introduced 2nd parameter, the alternate return file). To solve this
 rem problem a temporary batch file $RETAIN$.BAT is created initially (in
 rem the current directory) that contains this information hardcoded and
 rem calls RETAIN (or whatever it is renamed) with the necessary parameter:
echo echo off>$RETAIN$.BAT
 rem If no write of this auxiliary file is possible then cancel finally:
if not exist $RETAIN$.BAT goto NoPath
echo %0 %%1 %2>>$RETAIN$.BAT
 rem At the end (or somewhere suited) remove the temporary file $RETAIN$.BAT .
 rem Depending on the (path and) name (length) for RETAIN the path environment
 rem variable will be used up to a certain number of characters, maximally
 rem around 100.
%0 .path %path%

:NoPath
echo *** Necessary auxilary file $RETURN$.AUX could not be found - abort!
echo.
echo     Specify environment variable RETAIN to point to the path where
echo     $RETURN$.AUX resides (either from the DOS prompt or in AUTOEXEC.BAT).
echo     E.g. SET RETAIN=C:\UTIL\             (terminated with backslash).
echo     Or specify full path and file name to the eventual alternate auxiliary
echo     file for $RETURN$.AUX (e.g. SET RETAIN=C:\UTIL\AUX-FILE.$$$).
echo.
echo     Or specify path (terminated with '\') to or full file specification
echo     for $RETURN$.AUX as the first (and only) parameter for %0
goto end

:AltRtn
 rem Determine return-file (if not specified already as the second argument)
if "%RETURN%"=="" %0 %1 C:\RETURN
%0 %1 %RETURN%

:RETAIN
if not "%3"=="" goto AuxPath_checked
 rem Now %3 is empty: aux-path[aux-file] %1 specified by user, check existence:
 rem If %1 is _full_path_&_file_name_ of (alternate) $RETURN$.AUX then continue
if exist %1 goto AuxPath_checked
 rem If %1 is path only to explicit $RETURN$.AUX then restart RETAIN (%0) with
 rem _full_path_&_file_name_ as the first parameter
if exist %1$RETURN$.AUX %0 %1$RETURN$.AUX %2
 rem %1 has been specified by the user, but $RETURN$.AUX could not be found:
echo *** Auxiliary path[file] %1 is incorrect, file $RETURN$.AUX not found.
echo     Now trying to find $RETURN$.AUX using path (or full file specification):
echo     1. from environment variable RETAIN (path or full file specification)
echo     2. the root directory of C: (C:\) (or automatically any APPENDed path)
echo     3. the root of the current drive (\)
echo     4. the current directory (.\)
echo     5. the parent directory (..\)
echo     6. the same directory as RETAIN.BAT if RETAIN has been called by path
echo     7. from the DOS PATH variable (this may take quite a while)
echo.
goto Determine

:AuxPath_checked
 rem Check for existence of %2.BAT (return-file): if so, nesting has to take
 rem place. This is done by adding the current path parameter after the already
 rem present path parameters in %2.BAT, where it calls RETAIN.
if not exist %2.BAT goto Create
 rem %3 (and succeeding parameters) is the retained drive and subdirectory
 rem If path(s) stored are known resume with recreation of %2.BAT
if not "%3"=="" goto Create
 rem If no stored paths are known (just started RETAIN) force RETURN to
 rem supply the already stored path(s) (to add the current path to).
 rem This returns all currently stored paths as additional parameters up to 7
%2 %0 %1 .retain

:Create
 rem This is the part to RETAIN the current drive:path
 rem Creation of %2.BAT (the return-file)
if not "%1"==".recreate" if not "%9"=="" goto ListFull
 rem Initially explicitely delete %2.BAT in order to see if that works:
if exist %2.BAT del %2.BAT
if exist %2.BAT goto NoDelete
echo echo off>%2.BAT
if not exist %2.BAT goto NoReturn
echo rem --- %2.BAT 2.0 (c) 1992, Jim Groeneveld>>%2.BAT
echo if "%%1"=="?" %0 ?>>%2.BAT
echo if "%%1"=="/?" %0 ?>>%2.BAT
echo if "%%1"=="-?" %0 ?>>%2.BAT

echo if %%0==%2 goto AllRight>>%2.BAT
 rem Build check on unmoved/unrenamed %2.BAT into itself and
 rem make sure the original return-file is being run (if it exists):
 rem (this makes command lines longer, which may be undesired and unnecessary)
echo if not exist %2.BAT goto NoReturn>>%2.BAT
echo %2 %%1 %%2 %%3>>%2.BAT
echo :NoReturn>>%2.BAT
echo echo *** This file %2.BAT has been moved or renamed. DON'T! Abort!>>%2.BAT
echo echo     Execution of this BATch file %%0 may cause erroneous results.>>%2.BAT
echo goto end>>%2.BAT

echo :AllRight>>%2.BAT
echo if "%%1"=="" %%0 %0 .return .retain>>%2.BAT
echo if "%%1"=="*" %%0 %0 .list .retain>>%2.BAT
echo if not "%%3"==".retain" goto Retain>>%2.BAT
if "%3"=="" goto StoreNoPath
if "%3"==".empty" if not "%1"==".recreate" goto StoreNoPath
 rem %0 stores the current RETAIN.BAT file name (& eventually called path),
 rem which may be renamed, into RETURN.BAT
 rem %2 stores the name and location of the alternate RETURN file into it the
 rem first time it is being built. This information is valid to use instead of
 rem %%0 (the return file call) _as long as the user does not move and/or rename
 rem the generated RETURN file_. This is necessary with multiple return files
 rem to tell RETAIN the full specification of it to manipulate (read & write).
echo %%0 %0 %%2 %2 %3 %4 %5 %6 %7 %8 %9>>%2.BAT
 rem MANY (LONG) PATHS MAY CAUSE THE LINE ABOVE TO EXCEED 127 CHARACTERS.
 rem THIS WILL CREATE UNPREDICTABLE, AND ERRONEOUS RESULTS!!!!!!!!!!!!!!!
goto AddReplParams

:StoreNoPath
echo %%0 %0 %%2 %2>>%2.BAT
:AddReplParams
echo :Retain>>%2.BAT
if "%1"==".recreate" goto Recreate
 rem COPY adds a line '%1 %2 %3 %4 %5 %6 %7 %8 %9 ' without CRLF to RETURN
 rem to be replaced by:
 rem 1. the name (& path) of the current RETAIN.BAT file in RETURN;
 rem 2. the location (or name) of the auxiliary file $RETURN$.AUX or
 rem    specific processing arguments (beginning with a dot);
 rem 3. the full file specification of the (alternate) return-file;
 rem 4-9. nested path specifications or dot command.
copy %2.BAT+%1 /a %2.BAT /b >nul
 rem CD adds the current path (d:\[subdir]) to RETURN to be processed
 rem below when RETURN is called.
cd>>%2.BAT
echo :end>>%2.BAT

echo Type %2 from the DOS-prompt to return to
cd
goto end

:ListFull
echo *** The path list is full (7 paths stored). The current path can not be added!
echo     No further actions performed.
echo.
echo     In order to restart each time with an empty list when the system is booted
echo     add the following statement to your AUTOEXEC.BAT file:
echo     IF EXIST %2.BAT DEL %2.BAT (eventually redirect this to NUL)
echo.
:List
if "%3"==".empty" goto NoList
echo RETAIN: The paths currently stored are (in chronological order):
echo %3 %4 %5 %6 %7 %8 %9
goto end

:NoList
echo RETAIN: No paths stored currently.
goto end

:NoReturn
echo *** Writing %2.BAT not succeeded! No further actions taken!
echo.
echo     Possible causes:
echo     - specified drive does not exist
echo     - specified path (subdirectory) does not exist
echo     - %2.BAT exists as subdirectory, not as file
echo     - drive is write protected
echo     - diskdrive is full
echo     - directory entry table (for root directory) is full
echo.
echo     Take whatever measure is necessary (enable write, delete a file).
goto end

:NoDelete
echo *** Existing %2.BAT could not be deleted (and overwritten). Abort!
echo.
echo     Possible causes:
echo     - %2.BAT is write protected
echo     - drive is write protected
echo.
echo     Remove protection and retry.
goto end

:Recreate
 rem Like auxiliary file, but without the need to add a path, so ending in CRLF.
echo %%1 %%2 %%3 %%4 %%5 %%6 %%7 %%8 %%9>>%2.BAT
echo :end>>%2.BAT
goto end

:RETURN
 rem This is the part to return to the retained drive:path
 rem If list is empty then report and finish
if "%3"==".empty" goto NoList
 rem Reverse the order of paths stored (%3-%9) in order to process %3
 rem only if there are more paths stored, thus if at least %4 exists
if "%4"=="" goto Reversed
if "%1"==".reversed" goto Reversed
%0 .reversed %2 %9 %8 %7 %6 %5 %4 %3

:Reversed
for %%a in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if %3==%%a:\ goto CDD
 rem Otherwise forms as C:\\ (below) may slow down execution with networks.
 rem Check existence of %3 (might be removed in the meantime):
if exist %3\*.* goto CDD
 rem If command above did not find anything the subdir might exist but be empty.
 rem Avoid screen output if redirection below does not succeed: CTTY NUL.
ctty nul
 rem write dummy file to the rembered path %3 to check its existence
rem>%3\$0-BYTE$.NUL
ctty con
if exist %3\$0-BYTE$.NUL goto Delete
echo The drive:path %3 does not exist (anymore).
echo Or the disk may be write protected. Trying to return to it though.
goto CDD

:Delete
 rem Delete dummy check file
if exist %3\$0-BYTE$.NUL del %3\$0-BYTE$.NUL
:CDD
 rem Set retained drive
%3\
 rem Set retained subdirectory
cd %3
echo Returned to
cd

 rem Rereverse the order of the remaining paths stored and recreate %2.BAT
 rem without path %3
if "%4"=="" goto EmptyList
%0 .recreate %2 %9 %8 %7 %6 %5 %4
:EmptyList
 rem no more levels nested, thus either indicate or remove (if %2==C:\RETURN)
if not "%2"=="C:\RETURN" %0 .recreate %2 .empty
del %2.BAT>nul
goto end

:Help
echo --- RETAIN 2.0 (c) 1992, Jim Groeneveld; retains current path up to 7 levels.
echo.
echo Usage: 'RETAIN [aux-path[aux-file]*[/-]?+ [rtn-spec]]'
echo from the directory to retain, in which:
echo aux-path = drive:\subdir\ of auxiliary file $RETURN$.AUX, incl. trailing '\';
echo aux-file = the eventual alternate auxiliary file name for $RETURN$.AUX;
echo *        = list the currently stored paths (also with 'RETURN *');
echo ? (or /? or -?) = display this help (also with 'RETURN [/-]?');
echo +        = dummy first argument if only second one specified;
echo rtn-spec = (full drive, path and) file specification of the RETURN-file,
echo            without '.BAT' extension, default C:\RETURN.
echo.
echo DO NOT SPECIFY OTHER PARAMETERS. THIS WILL PRODUCE ERRONEOUS RESULTS!
echo RETAIN may be called successive times to store up to 7 paths.
echo.
echo To return to the very last retained path (drive & subdirectory) just enter
echo 'RETURN' (or alternative name) (without any arguments) from the DOS prompt
echo (the literal command RETURN, not only the RETURN/ENTER-key). This path is
echo removed from the list and RETAIN thus has one more level to store the next
echo time. Enter 'RETURN *' to list the currently stored paths.
goto end

:Path          SUBROUTINE PATH
shift
:chkpath
 rem Check each path entry for the presence of $RETURN$.AUX:
if "%1"=="" goto NotFound
 rem Check root specifications (ending with a trailing \) firstly:             *
for %%a in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if "%%a:\"=="%1" goto RootPath *
for %%a in (a b c d e f g h i j k l m n o p q r s t u v w x y z) do if "%%a:\"=="%1" goto RootPath *
 rem Path spec is not a root                                                   *
 rem If $RETURN.AUX has been found then restart with location as parameter
if exist %1\$RETURN$.AUX $RETAIN$ %1\$RETURN$.AUX
goto NextPath                                                                  *
:RootPath                                                                      *
 rem If $RETURN.AUX has been found then restart with location as parameter     *
if exist %1$RETURN$.AUX $RETAIN$ %1$RETURN$.AUX
 rem goto NextPath                                                             *
:NextPath                                                                      *
 rem Check next path entry:
shift
goto chkpath
:NotFound
 rem path or auxiliary file not found, indicate
$RETAIN$ .notfound
 rem Lines marked with * may eventually be deleted all at once resulting in a
 rem slightly changed check algorithm: 1. _with_ '\' and 2. _without_ '\'.
 rem These lines should work, however, with the * included.
rem goto end

:end
 rem delete auxiliary file $RETAIN$.BAT if present
if exist $RETAIN$.BAT del $RETAIN$.BAT
